﻿
using MTWorkHR.Core.Entities;
using MTWorkHR.Core.IRepositories;
using MTWorkHR.Core.IRepositories.Base;


namespace MTWorkHR.Core.UnitOfWork
{
    public interface IUnitOfWork
    {
        IPermissionRepository Permission { get; }
        ICompanyRepository Company { get; }
        Task<int> CompleteAsync();

        void BeginTran();

        void CommitTran();

        void RollbackTran();

        object GetRepositoryByName(string name);
    }
}
